gi-glib-2.0.29: GLib bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.GLib.Structs.Date

Contents

- Exported types
- Methods
  - addDays
  - addMonths
  - addYears
  - clamp
  - clear
  - compare
  - copy
  - daysBetween
  - free
  - getDay
  - getDayOfYear
  - getDaysInMonth
  - getIso8601WeekOfYear
  - getJulian
  - getMondayWeekOfYear
  - getMondayWeeksInYear
  - getMonth
  - getSundayWeekOfYear
  - getSundayWeeksInYear
  - getWeekday
  - getYear
  - isFirstOfMonth
  - isLastOfMonth
  - isLeapYear
  - new
  - newDmy
  - newJulian
  - order
  - setDay
  - setDmy
  - setJulian
  - setMonth
  - setParse
  - setTime
  - setTimeT
  - setTimeVal
  - setYear
  - strftime
  - subtractDays
  - subtractMonths
  - subtractYears
  - toStructTm
  - valid
  - validDay
  - validDmy
  - validJulian
  - validMonth
  - validWeekday
  - validYear
- Properties
  - day
  - dmy
  - julian
  - julianDays
  - month
  - year

Description

`GDate` is a struct for calendrical calculations.

The `GDate` data structure represents a day between January 1, Year 1, and sometime a few thousand years in the future (right now it will go to the year 65535 or so, but `dateSetParse` only parses up to the year 8000 or so - just count on "a few thousand"). `GDate` is meant to represent everyday dates, not astronomical dates or historical dates or ISO timestamps or the like. It extrapolates the current Gregorian calendar forward and backward in time; there is no attempt to change the calendar to match time periods or locations. `GDate` does not store time information; it represents a day.

The `GDate` implementation has several nice features; it is only a 64-bit struct, so storing large numbers of dates is very efficient. It can keep both a Julian and day-month-year representation of the date, since some calculations are much easier with one representation or the other. A Julian representation is simply a count of days since some fixed day in the past; for `Date` the fixed day is January 1, 1 AD. ("Julian" dates in the `Date` API aren't really Julian dates in the technical sense; technically, Julian dates count from the start of the Julian period, Jan 1, 4713 BC).

`GDate` is simple to use. First you need a "blank" date; you can get a dynamically allocated date from `dateNew`, or you can declare an automatic variable or array and initialize it by calling `dateClear`. A cleared date is safe; it's safe to call `dateSetDmy` and the other mutator functions to initialize the value of a cleared date. However, a cleared date is initially invalid, meaning that it doesn't represent a day that exists. It is undefined to call any of the date calculation routines on an invalid date. If you obtain a date from a user or other unpredictable source, you should check its validity with the `dateValid` predicate. `dateValid` is also used to check for errors with `dateSetParse` and other functions that can fail. Dates can be invalidated by calling `dateClear` again.

It is very important to use the API to access the `GDate` struct. Often only the day-month-year or only the Julian representation is valid. Sometimes neither is valid. Use the API.

GLib also features `GDateTime` which represents a precise time.

Synopsis

- newtype Date = Date (ManagedPtr Date)
- newZeroDate :: MonadIO m => m Date
- dateAddDays :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateAddMonths :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateAddYears :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateClamp :: (HasCallStack, MonadIO m) => Date -> Date -> Date -> m ()
- dateClear :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateCompare :: (HasCallStack, MonadIO m) => Date -> Date -> m Int32
- dateCopy :: (HasCallStack, MonadIO m) => Date -> m Date
- dateDaysBetween :: (HasCallStack, MonadIO m) => Date -> Date -> m Int32
- dateFree :: (HasCallStack, MonadIO m) => Date -> m ()
- dateGetDay :: (HasCallStack, MonadIO m) => Date -> m Word8
- dateGetDayOfYear :: (HasCallStack, MonadIO m) => Date -> m Word32
- dateGetDaysInMonth :: (HasCallStack, MonadIO m) => DateMonth -> Word16 -> m Word8
- dateGetIso8601WeekOfYear :: (HasCallStack, MonadIO m) => Date -> m Word32
- dateGetJulian :: (HasCallStack, MonadIO m) => Date -> m Word32
- dateGetMondayWeekOfYear :: (HasCallStack, MonadIO m) => Date -> m Word32
- dateGetMondayWeeksInYear :: (HasCallStack, MonadIO m) => Word16 -> m Word8
- dateGetMonth :: (HasCallStack, MonadIO m) => Date -> m DateMonth
- dateGetSundayWeekOfYear :: (HasCallStack, MonadIO m) => Date -> m Word32
- dateGetSundayWeeksInYear :: (HasCallStack, MonadIO m) => Word16 -> m Word8
- dateGetWeekday :: (HasCallStack, MonadIO m) => Date -> m DateWeekday
- dateGetYear :: (HasCallStack, MonadIO m) => Date -> m Word16
- dateIsFirstOfMonth :: (HasCallStack, MonadIO m) => Date -> m Bool
- dateIsLastOfMonth :: (HasCallStack, MonadIO m) => Date -> m Bool
- dateIsLeapYear :: (HasCallStack, MonadIO m) => Word16 -> m Bool
- dateNew :: (HasCallStack, MonadIO m) => m Date
- dateNewDmy :: (HasCallStack, MonadIO m) => Word8 -> DateMonth -> Word16 -> m Date
- dateNewJulian :: (HasCallStack, MonadIO m) => Word32 -> m Date
- dateOrder :: (HasCallStack, MonadIO m) => Date -> Date -> m ()
- dateSetDay :: (HasCallStack, MonadIO m) => Date -> Word8 -> m ()
- dateSetDmy :: (HasCallStack, MonadIO m) => Date -> Word8 -> DateMonth -> Word16 -> m ()
- dateSetJulian :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateSetMonth :: (HasCallStack, MonadIO m) => Date -> DateMonth -> m ()
- dateSetParse :: (HasCallStack, MonadIO m) => Date -> Text -> m ()
- dateSetTime :: (HasCallStack, MonadIO m) => Date -> Int32 -> m ()
- dateSetTimeT :: (HasCallStack, MonadIO m) => Date -> CLong -> m ()
- dateSetTimeVal :: (HasCallStack, MonadIO m) => Date -> TimeVal -> m ()
- dateSetYear :: (HasCallStack, MonadIO m) => Date -> Word16 -> m ()
- dateStrftime :: (HasCallStack, MonadIO m) => Text -> Word64 -> Text -> Date -> m Word64
- dateSubtractDays :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateSubtractMonths :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateSubtractYears :: (HasCallStack, MonadIO m) => Date -> Word32 -> m ()
- dateToStructTm :: (HasCallStack, MonadIO m) => Date -> Ptr () -> m ()
- dateValid :: (HasCallStack, MonadIO m) => Date -> m Bool
- dateValidDay :: (HasCallStack, MonadIO m) => Word8 -> m Bool
- dateValidDmy :: (HasCallStack, MonadIO m) => Word8 -> DateMonth -> Word16 -> m Bool
- dateValidJulian :: (HasCallStack, MonadIO m) => Word32 -> m Bool
- dateValidMonth :: (HasCallStack, MonadIO m) => DateMonth -> m Bool
- dateValidWeekday :: (HasCallStack, MonadIO m) => DateWeekday -> m Bool
- dateValidYear :: (HasCallStack, MonadIO m) => Word16 -> m Bool
- getDateDay :: MonadIO m => Date -> m Word32
- setDateDay :: MonadIO m => Date -> Word32 -> m ()
- getDateDmy :: MonadIO m => Date -> m Word32
- setDateDmy :: MonadIO m => Date -> Word32 -> m ()
- getDateJulian :: MonadIO m => Date -> m Word32
- setDateJulian :: MonadIO m => Date -> Word32 -> m ()
- getDateJulianDays :: MonadIO m => Date -> m Word32
- setDateJulianDays :: MonadIO m => Date -> Word32 -> m ()
- getDateMonth :: MonadIO m => Date -> m Word32
- setDateMonth :: MonadIO m => Date -> Word32 -> m ()
- getDateYear :: MonadIO m => Date -> m Word32
- setDateYear :: MonadIO m => Date -> Word32 -> m ()

# Exported types

newtype Date Source #

Memory-managed wrapper type.

Constructors

Date (ManagedPtr Date) |

#### Instances

Instances details

Eq Date Source # |
Instance details Defined in GI.GLib.Structs.Date Methods (==) :: Date -> Date -> Bool Source # (/=) :: Date -> Date -> Bool Source #
GBoxed Date Source # |
Instance details Defined in GI.GLib.Structs.Date
ManagedPtrNewtype Date Source # |
Instance details Defined in GI.GLib.Structs.Date Methods toManagedPtr :: Date -> ManagedPtr Date Source #
TypedObject Date Source # |
Instance details Defined in GI.GLib.Structs.Date Methods glibType :: IO GType Source #
HasParentTypes Date Source # |
Instance details Defined in GI.GLib.Structs.Date
tag ~ 'AttrSet => Constructible Date tag Source # |
Instance details Defined in GI.GLib.Structs.Date Methods new :: MonadIO m => (ManagedPtr Date -> Date) -> [AttrOp Date tag] -> m Date Source #
IsGValue (Maybe Date) Source # | Convert `Date` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.GLib.Structs.Date Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Date -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Date) Source #
type ParentTypes Date Source # |
Instance details Defined in GI.GLib.Structs.Date type ParentTypes Date = '[] :: [Type]

newZeroDate :: MonadIO m => m Date Source #

Construct a `Date` struct initialized to zero.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

addDays, addMonths, addYears, clamp, clear, compare, copy, daysBetween, free, isFirstOfMonth, isLastOfMonth, order, subtractDays, subtractMonths, subtractYears, toStructTm, valid.

#### Getters

getDay, getDayOfYear, getIso8601WeekOfYear, getJulian, getMondayWeekOfYear, getMonth, getSundayWeekOfYear, getWeekday, getYear.

#### Setters

setDay, setDmy, setJulian, setMonth, setParse, setTime, setTimeT, setTimeVal, setYear.

## addDays

dateAddDays Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to increment
-> Word32 | `nDays`: number of days to move the date forward
-> m () |

Increments a date some number of days. To move forward by weeks, add weeks*7 days. The date must be valid.

## addMonths

dateAddMonths Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to increment
-> Word32 | `nMonths`: number of months to move forward
-> m () |

Increments a date by some number of months. If the day of the month is greater than 28, this routine may change the day of the month (because the destination month may not have the current day in it). The date must be valid.

## addYears

dateAddYears Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to increment
-> Word32 | `nYears`: number of years to move forward
-> m () |

Increments a date by some number of years. If the date is February 29, and the destination year is not a leap year, the date will be changed to February 28. The date must be valid.

## clamp

dateClamp Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to clamp
-> Date | `minDate`: minimum accepted value for `date`
-> Date | `maxDate`: maximum accepted value for `date`
-> m () |

If `date` is prior to `minDate`, sets `date` equal to `minDate`. If `date` falls after `maxDate`, sets `date` equal to `maxDate`. Otherwise, `date` is unchanged. Either of `minDate` and `maxDate` may be `Nothing`. All non-`Nothing` dates must be valid.

## clear

dateClear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: pointer to one or more dates to clear
-> Word32 | `nDates`: number of dates to clear
-> m () |

Initializes one or more `Date` structs to a safe but invalid state. The cleared dates will not represent an existing date, but will not contain garbage. Useful to init a date declared on the stack. Validity can be tested with `dateValid`.

## compare

dateCompare Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `lhs`: first date to compare
-> Date | `rhs`: second date to compare
-> m Int32 | Returns: 0 for equal, less than zero if `lhs` is less than `rhs`, greater than zero if `lhs` is greater than `rhs`

`qsort()`-style comparison function for dates. Both dates must be valid.

## copy

dateCopy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to copy
-> m Date | Returns: a newly-allocated `Date` initialized from `date`

Copies a GDate to a newly-allocated GDate. If the input was invalid (as determined by `dateValid`), the invalid state will be copied as is into the new object.

Since: 2.56

## daysBetween

dateDaysBetween Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date1`: the first date
-> Date | `date2`: the second date
-> m Int32 | Returns: the number of days between `date1` and `date2`

Computes the number of days between two dates. If `date2` is prior to `date1`, the returned value is negative. Both dates must be valid.

## free

dateFree Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to free
-> m () |

Frees a `Date` returned from `dateNew`.

## getDay

dateGetDay Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to extract the day of the month from
-> m Word8 | Returns: day of the month

Returns the day of the month. The date must be valid.

## getDayOfYear

dateGetDayOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to extract day of year from
-> m Word32 | Returns: day of the year

Returns the day of the year, where Jan 1 is the first day of the year. The date must be valid.

## getDaysInMonth

dateGetDaysInMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateMonth | `month`: month
-> Word16 | `year`: year
-> m Word8 | Returns: number of days in `month` during the `year`

Returns the number of days in a month, taking leap years into account.

## getIso8601WeekOfYear

dateGetIso8601WeekOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a valid `Date`
-> m Word32 | Returns: ISO 8601 week number of the year.

Returns the week of the year, where weeks are interpreted according to ISO 8601.

Since: 2.6

## getJulian

dateGetJulian Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to extract the Julian day from
-> m Word32 | Returns: Julian day

Returns the Julian day or "serial number" of the `Date`. The Julian day is simply the number of days since January 1, Year 1; i.e., January 1, Year 1 is Julian day 1; January 2, Year 1 is Julian day 2, etc. The date must be valid.

## getMondayWeekOfYear

dateGetMondayWeekOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> m Word32 | Returns: week of the year

Returns the week of the year, where weeks are understood to start on Monday. If the date is before the first Monday of the year, return 0. The date must be valid.

## getMondayWeeksInYear

dateGetMondayWeeksInYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word16 | `year`: a year
-> m Word8 | Returns: number of Mondays in the year

Returns the number of weeks in the year, where weeks are taken to start on Monday. Will be 52 or 53. The date must be valid. (Years always have 52 7-day periods, plus 1 or 2 extra days depending on whether it's a leap year. This function is basically telling you how many Mondays are in the year, i.e. there are 53 Mondays if one of the extra days happens to be a Monday.)

## getMonth

dateGetMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to get the month from
-> m DateMonth | Returns: month of the year as a `DateMonth`

Returns the month of the year. The date must be valid.

## getSundayWeekOfYear

dateGetSundayWeekOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> m Word32 | Returns: week number

Returns the week of the year during which this date falls, if weeks are understood to begin on Sunday. The date must be valid. Can return 0 if the day is before the first Sunday of the year.

## getSundayWeeksInYear

dateGetSundayWeeksInYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word16 | `year`: year to count weeks in
-> m Word8 | Returns: the number of weeks in `year`

Returns the number of weeks in the year, where weeks are taken to start on Sunday. Will be 52 or 53. The date must be valid. (Years always have 52 7-day periods, plus 1 or 2 extra days depending on whether it's a leap year. This function is basically telling you how many Sundays are in the year, i.e. there are 53 Sundays if one of the extra days happens to be a Sunday.)

## getWeekday

dateGetWeekday Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> m DateWeekday | Returns: day of the week as a `DateWeekday`.

Returns the day of the week for a `Date`. The date must be valid.

## getYear

dateGetYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> m Word16 | Returns: year in which the date falls

Returns the year of a `Date`. The date must be valid.

## isFirstOfMonth

dateIsFirstOfMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to check
-> m Bool | Returns: `True` if the date is the first of the month

Returns `True` if the date is on the first of a month. The date must be valid.

## isLastOfMonth

dateIsLastOfMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to check
-> m Bool | Returns: `True` if the date is the last day of the month

Returns `True` if the date is the last day of the month. The date must be valid.

## isLeapYear

dateIsLeapYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word16 | `year`: year to check
-> m Bool | Returns: `True` if the year is a leap year

Returns `True` if the year is a leap year.

For the purposes of this function, leap year is every year divisible by 4 unless that year is divisible by 100. If it is divisible by 100 it would be a leap year only if that year is also divisible by 400.

## new

dateNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Date | Returns: a newly-allocated `Date`

Allocates a `Date` and initializes it to a safe state. The new date will be cleared (as if you'd called `dateClear`) but invalid (it won't represent an existing day). Free the return value with `dateFree`.

## newDmy

dateNewDmy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word8 | `day`: day of the month
-> DateMonth | `month`: month of the year
-> Word16 | `year`: year
-> m Date | Returns: a newly-allocated `Date` initialized with `day`, `month`, and `year`

Create a new `Date` representing the given day-month-year triplet.

The triplet you pass in must represent a valid date. Use `dateValidDmy` if needed to validate it. The returned `Date` is guaranteed to be non-`Nothing` and valid.

## newJulian

dateNewJulian Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 | `julianDay`: days since January 1, Year 1
-> m Date | Returns: a newly-allocated `Date` initialized with `julianDay`

Create a new `Date` representing the given Julian date.

The `julianDay` you pass in must be valid. Use `dateValidJulian` if needed to validate it. The returned `Date` is guaranteed to be non-`Nothing` and valid.

## order

dateOrder Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date1`: the first date
-> Date | `date2`: the second date
-> m () |

Checks if `date1` is less than or equal to `date2`, and swap the values if this is not the case.

## setDay

dateSetDay Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> Word8 | `day`: day to set
-> m () |

Sets the day of the month for a `Date`. If the resulting day-month-year triplet is invalid, the date will be invalid.

## setDmy

dateSetDmy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> Word8 | `day`: day
-> DateMonth | `month`: month
-> Word16 | `y`: year
-> m () |

Sets the value of a `Date` from a day, month, and year. The day-month-year triplet must be valid; if you aren't sure it is, call `dateValidDmy` to check before you set it.

## setJulian

dateSetJulian Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> Word32 | `julianDate`: Julian day number (days since January 1, Year 1)
-> m () |

Sets the value of a `Date` from a Julian day number.

## setMonth

dateSetMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> DateMonth | `month`: month to set
-> m () |

Sets the month of the year for a `Date`. If the resulting day-month-year triplet is invalid, the date will be invalid.

## setParse

dateSetParse Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to fill in
-> Text | `str`: string to parse
-> m () |

Parses a user-inputted string `str`, and try to figure out what date it represents, taking the [current locale][setlocale] into account. If the string is successfully parsed, the date will be valid after the call. Otherwise, it will be invalid. You should check using `dateValid` to see whether the parsing succeeded.

This function is not appropriate for file formats and the like; it isn't very precise, and its exact behavior varies with the locale. It's intended to be a heuristic routine that guesses what the user means by a given string (and it does work pretty well in that capacity).

## setTime

dateSetTime Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`.
-> Int32 | `time_`: `GTime` value to set.
-> m () |

Deprecated: (Since version 2.10)Use `dateSetTimeT` instead.

Sets the value of a date from a `GTime` value. The time to date conversion is done using the user's current timezone.

## setTimeT

dateSetTimeT Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> CLong | `timet`: time_t value to set
-> m () |

Sets the value of a date to the date corresponding to a time specified as a time_t. The time to date conversion is done using the user's current timezone.

To set the value of a date to the current day, you could write:

### C code

    time_t now = time (NULL);
    if (now == (time_t) -1)
      // handle the error
    g_date_set_time_t (date, now);

Since: 2.10

## setTimeVal

dateSetTimeVal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> TimeVal | `timeval`: `TimeVal` value to set
-> m () |

Deprecated: (Since version 2.62)t`TimeVal` is not year-2038-safe. Use `dateSetTimeT` instead.

Sets the value of a date from a `TimeVal` value. Note that the `tvUsec` member is ignored, because `Date` can't make use of the additional precision.

The time to date conversion is done using the user's current timezone.

Since: 2.10

## setYear

dateSetYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date`
-> Word16 | `year`: year to set
-> m () |

Sets the year for a `Date`. If the resulting day-month-year triplet is invalid, the date will be invalid.

## strftime

dateStrftime Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `s`: destination buffer
-> Word64 | `slen`: buffer size
-> Text | `format`: format string
-> Date | `date`: valid `Date`
-> m Word64 | Returns: number of characters written to the buffer, or 0 the buffer was too small

Generates a printed representation of the date, in a [locale][setlocale]-specific way. Works just like the platform's C library `strftime()` function, but only accepts date-related formats; time-related formats give undefined results. Date must be valid. Unlike `strftime()` (which uses the locale encoding), works on a UTF-8 format string and stores a UTF-8 result.

This function does not provide any conversion specifiers in addition to those implemented by the platform's C library. For example, don't expect that using `dateStrftime` would make the %F provided by the C99 `strftime()` work on Windows where the C library only complies to C89.

## subtractDays

dateSubtractDays Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to decrement
-> Word32 | `nDays`: number of days to move
-> m () |

Moves a date some number of days into the past. To move by weeks, just move by weeks*7 days. The date must be valid.

## subtractMonths

dateSubtractMonths Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to decrement
-> Word32 | `nMonths`: number of months to move
-> m () |

Moves a date some number of months into the past. If the current day of the month doesn't exist in the destination month, the day of the month may change. The date must be valid.

## subtractYears

dateSubtractYears Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to decrement
-> Word32 | `nYears`: number of years to move
-> m () |

Moves a date some number of years into the past. If the current day doesn't exist in the destination year (i.e. it's February 29 and you move to a non-leap-year) then the day is changed to February 29. The date must be valid.

## toStructTm

dateToStructTm Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to set the struct tm from
-> Ptr () | `tm`: struct tm to fill
-> m () |

Fills in the date-related bits of a struct tm using the `date` value. Initializes the non-date parts with something safe but meaningless.

## valid

dateValid Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Date | `date`: a `Date` to check
-> m Bool | Returns: Whether the date is valid

Returns `True` if the `Date` represents an existing day. The date must not contain garbage; it should have been initialized with `dateClear` if it wasn't allocated by one of the `dateNew` variants.

## validDay

dateValidDay Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word8 | `day`: day to check
-> m Bool | Returns: `True` if the day is valid

Returns `True` if the day of the month is valid (a day is valid if it's between 1 and 31 inclusive).

## validDmy

dateValidDmy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word8 | `day`: day
-> DateMonth | `month`: month
-> Word16 | `year`: year
-> m Bool | Returns: `True` if the date is a valid one

Returns `True` if the day-month-year triplet forms a valid, existing day in the range of days `Date` understands (Year 1 or later, no more than a few thousand years in the future).

## validJulian

dateValidJulian Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 | `julianDate`: Julian day to check
-> m Bool | Returns: `True` if the Julian day is valid

Returns `True` if the Julian day is valid. Anything greater than zero is basically a valid Julian, though there is a 32-bit limit.

## validMonth

dateValidMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateMonth | `month`: month
-> m Bool | Returns: `True` if the month is valid

Returns `True` if the month value is valid. The 12 `DateMonth` enumeration values are the only valid months.

## validWeekday

dateValidWeekday Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateWeekday | `weekday`: weekday
-> m Bool | Returns: `True` if the weekday is valid

Returns `True` if the weekday is valid. The seven `DateWeekday` enumeration values are the only valid weekdays.

## validYear

dateValidYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word16 | `year`: year
-> m Bool | Returns: `True` if the year is valid

Returns `True` if the year is valid. Any year greater than 0 is valid, though there is a 16-bit limit to what `Date` will understand.

# Properties

## day

the day of the day-month-year representation of the date, as a number between 1 and 31

getDateDay :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`day`” field. When overloading is enabled, this is equivalent to

    get date #day

setDateDay :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`day`” field. When overloading is enabled, this is equivalent to

    set date [ #day := value ]

## dmy

this is set if `day`, `month` and `year` are valid

getDateDmy :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`dmy`” field. When overloading is enabled, this is equivalent to

    get date #dmy

setDateDmy :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`dmy`” field. When overloading is enabled, this is equivalent to

    set date [ #dmy := value ]

## julian

this bit is set if `julianDays` is valid

getDateJulian :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`julian`” field. When overloading is enabled, this is equivalent to

    get date #julian

setDateJulian :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`julian`” field. When overloading is enabled, this is equivalent to

    set date [ #julian := value ]

## julianDays

the Julian representation of the date

getDateJulianDays :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`julian_days`” field. When overloading is enabled, this is equivalent to

    get date #julianDays

setDateJulianDays :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`julian_days`” field. When overloading is enabled, this is equivalent to

    set date [ #julianDays := value ]

## month

the month of the day-month-year representation of the date, as a number between 1 and 12

getDateMonth :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`month`” field. When overloading is enabled, this is equivalent to

    get date #month

setDateMonth :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`month`” field. When overloading is enabled, this is equivalent to

    set date [ #month := value ]

## year

the year of the day-month-year representation of the date

getDateYear :: MonadIO m => Date -> m Word32 Source #

Get the value of the “`year`” field. When overloading is enabled, this is equivalent to

    get date #year

setDateYear :: MonadIO m => Date -> Word32 -> m () Source #

Set the value of the “`year`” field. When overloading is enabled, this is equivalent to

    set date [ #year := value ]